diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java
index 7cfbb1c7c..ed91ab52f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.World;
 
@@ -12,7 +12,7 @@ public abstract class EntityEntry<T extends Entity>{
     public static final EntityEntry<Entity> blankEntry = new BlankEntry();
     public EntityEntry(){}
     public abstract void onTick(T entity);
-    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, T entity);
+    public abstract List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, T entity);
     public abstract T getEntityInstance(Minecraft mc, World world);
     public abstract void onOpen();
     public abstract void onClose();
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
index 12258c0f6..525817d01 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 
 import net.minecraft.core.entity.FallingBlockEntity;
@@ -20,11 +20,11 @@ public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, FallingBlockEntity sand) {
-        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, sand.blockID) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, FallingBlockEntity sand) {
+        TextCycleElement<Integer> blockIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, sand.blockID) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleBlockId(current, offset);
+                return ModelViewerScreen.cycleBlockId(current, offset);
             }
 
             @Override
@@ -44,7 +44,7 @@ public class EntityFallingSandEntry extends EntityEntry<FallingBlockEntity>{
         blockIdCycle.textField.setPrefaceText("ID: ");
         blockIdCycle.textField.setPlaceholder("Block ID");
         blockIdCycle.setOnValueChanged(() -> sand.blockID = blockIdCycle.getCurrentElement());
-        return new ArrayList<GuiButton>(){{add(blockIdCycle);}};
+        return new ArrayList<ButtonElement>(){{add(blockIdCycle);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
index f310e30f3..0206ac0e8 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -27,15 +27,15 @@ public class EntityFireflyEntry extends EntityEntry<FireflyClusterMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, FireflyClusterMob fireflyCluster) {
-        List<GuiButton> buttonList = new ArrayList<>();
-        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", 0), 0f);
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, FireflyClusterMob fireflyCluster) {
+        List<ButtonElement> buttonList = new ArrayList<>();
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", 0), 0f);
         slider.setOnValueChanged(() -> {
             fireflyCluster.setClusterSize((int) (slider.sliderValue * (fireflyCluster.maxClusterSize)));
             slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", fireflyCluster.getClusterSize());
         });
 
-        GuiListSelectorButton<FireflyClusterMob.FireflyColor> button = new GuiListSelectorButton<FireflyClusterMob.FireflyColor>(-1, - 120, slider.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.fireflycluster.button.cycle"), FireflyClusterMob.FireflyColor.fireFlyColors.values(), FireflyClusterMob.FireflyColor.GREEN) {
+        ListSelectorButtonElement<FireflyClusterMob.FireflyColor> button = new ListSelectorButtonElement<FireflyClusterMob.FireflyColor>(-1, - 120, slider.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.fireflycluster.button.cycle"), FireflyClusterMob.FireflyColor.fireFlyColors.values(), FireflyClusterMob.FireflyColor.GREEN) {
             @Override
             public String getNameFromElement(FireflyClusterMob.FireflyColor element) {
                 return element.getParticleName();
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
index 8aada06d3..d13ea3380 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.item.Item;
@@ -24,13 +24,13 @@ public class EntityItemEntry extends EntityEntry<ItemEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, ItemEntity itemEntity) {
-        List<GuiButton> buttonList = new ArrayList<>();
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, ItemEntity itemEntity) {
+        List<ButtonElement> buttonList = new ArrayList<>();
         itemEntity.item = Blocks.STONE.getDefaultStack();
-        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, 1) {
+        TextCycleElement<Integer> itemIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, 1) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleItemId(current, offset);
+                return ModelViewerScreen.cycleItemId(current, offset);
             }
 
             @Override
@@ -50,7 +50,7 @@ public class EntityItemEntry extends EntityEntry<ItemEntity>{
         itemIdCycle.textField.setPrefaceText("ID: ");
         itemIdCycle.textField.setPlaceholder("Item ID");
 
-        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
+        TextCycleElement<Integer> metaCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return (current + offset) & 0x3FFF;
@@ -72,7 +72,7 @@ public class EntityItemEntry extends EntityEntry<ItemEntity>{
         };
         metaCycle.textField.setPrefaceText("Meta: ");
         metaCycle.textField.setPlaceholder("Meta");
-        GuiListenerSlider sizeSlider = new GuiListenerSlider(-1, - 120, metaCycle.yPosition + 21,120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", 1), 1/64f);
+        ListenerSliderElement sizeSlider = new ListenerSliderElement(-1, - 120, metaCycle.yPosition + 21,120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", 1), 1/64f);
 
         itemIdCycle.setOnValueChanged(() -> itemEntity.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
         metaCycle.setOnValueChanged(() -> itemEntity.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
index 1d64b63d9..8668dc062 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -19,10 +19,10 @@ public class EntityMinecartEntry extends EntityEntry<MinecartEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, MinecartEntity minecart) {
-        GuiListenerButton button = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, MinecartEntity minecart) {
+        ListenerButtonElement button = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
         button.setActionListener(() -> minecart.type = (minecart.type + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3);
-        return new ArrayList<GuiButton>(){{add(button);}};
+        return new ArrayList<ButtonElement>(){{add(button);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
index 8e0122dce..94dc7c958 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.PaintingEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.world.World;
@@ -18,13 +18,13 @@ public class EntityPaintingEntry extends EntityEntry<PaintingEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, PaintingEntity painting) {
-        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, painting.art.key, 0f);
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, PaintingEntity painting) {
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 0, 120, 20, painting.art.key, 0f);
         slider.setOnValueChanged(() -> {
             painting.art = ArtType.values.get((int) (slider.sliderValue * (ArtType.values.size() - 1)));
             slider.displayString = painting.art.key;
         });
-        return new ArrayList<GuiButton>(){{add(slider);}};
+        return new ArrayList<ButtonElement>(){{add(slider);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
index 7c4fd4fc6..af51cb4bf 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
@@ -1,11 +1,10 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.animal.SheepMob;
-import net.minecraft.core.item.DyeItem;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
@@ -20,9 +19,9 @@ public class EntitySheepEntry extends EntityEntry<SheepMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, SheepMob sheep) {
-        List<GuiButton> buttonList = new ArrayList<>();
-        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", "White"), 0f);
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, SheepMob sheep) {
+        List<ButtonElement> buttonList = new ArrayList<>();
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", "White"), 0f);
         slider.setOnValueChanged(() -> {
             sheep.setFleeceColor(DyeColor.colorFromBlockMeta((int) (slider.sliderValue * 15)));
             String color = sheep.getFleeceColor().colorID;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
index 1da73ad79..978362242 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.monster.SlimeMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -18,9 +18,9 @@ public class EntitySlimeEntry extends EntityEntry<SlimeMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, SlimeMob entity) {
-        List<GuiButton> buttonList = new ArrayList<>();
-        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", 1), 0f);
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, SlimeMob entity) {
+        List<ButtonElement> buttonList = new ArrayList<>();
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", 1), 0f);
         slider.setOnValueChanged(() -> {
             entity.setSlimeSize((int) (slider.sliderValue * 4) + 1);
             slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", entity.getSlimeSize());
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
index 102fb5a7c..37dfdb1b1 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.TNTPrimedEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -18,14 +18,14 @@ public class EntityTNTEntry extends EntityEntry<TNTPrimedEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, TNTPrimedEntity tnt) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, TNTPrimedEntity tnt) {
         tnt.fuse = 80;
-        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", 80), 1f);
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", 80), 1f);
         slider.setOnValueChanged(() -> {
             tnt.fuse = (int) (slider.sliderValue * 80);
             slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", tnt.fuse);
         });
-        return new ArrayList<GuiButton>(){{add(slider);}};
+        return new ArrayList<ButtonElement>(){{add(slider);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
index d63598723..1bf36df72 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
@@ -1,15 +1,14 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.entity.animal.WolfMob;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.lang.I18n;
@@ -31,10 +30,10 @@ public class EntityWolfEntry extends EntityEntry<WolfMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, WolfMob entityWolf) {
-        List<GuiButton> buttonList = new ArrayList<>();
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, WolfMob entityWolf) {
+        List<ButtonElement> buttonList = new ArrayList<>();
         boolean isTamed = entityWolf.isWolfTamed();
-        GuiListenerButton tamed = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.tamed", isTamed));
+        ListenerButtonElement tamed = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.tamed", isTamed));
         tamed.setActionListener(() -> {
             boolean _tamed = !entityWolf.isWolfTamed();
             entityWolf.setWolfTamed(_tamed);
@@ -42,7 +41,7 @@ public class EntityWolfEntry extends EntityEntry<WolfMob>{
         });
 
         boolean isSitting = entityWolf.isWolfSitting();
-        GuiListenerButton sitting = new GuiListenerButton(-1, - 120, tamed.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.sitting", isSitting));
+        ListenerButtonElement sitting = new ListenerButtonElement(-1, - 120, tamed.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.sitting", isSitting));
         sitting.setActionListener(() -> {
             boolean _sitting = !entityWolf.isWolfSitting();
             entityWolf.setWolfSitting(_sitting);
@@ -50,14 +49,14 @@ public class EntityWolfEntry extends EntityEntry<WolfMob>{
         });
 
         boolean isAngry = entityWolf.isWolfAngry();
-        GuiListenerButton angry = new GuiListenerButton(-1, - 120, sitting.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.angry", isAngry));
+        ListenerButtonElement angry = new ListenerButtonElement(-1, - 120, sitting.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.angry", isAngry));
         angry.setActionListener(() -> {
             boolean _angry = !entityWolf.isWolfAngry();
             entityWolf.setWolfAngry(_angry);
             angry.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.angry", _angry);
         });
 
-        GuiListSelectorButton<ArmorMaterial> armor = new GuiListSelectorButton<ArmorMaterial>(-1, - 120, angry.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.wolf.button.armor"), armorMaterials,null) {
+        ListSelectorButtonElement<ArmorMaterial> armor = new ListSelectorButtonElement<ArmorMaterial>(-1, - 120, angry.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.wolf.button.armor"), armorMaterials,null) {
             @Override
             public String getNameFromElement(ArmorMaterial element) {
                 return element == null ? "none" : element.identifier.toString();
@@ -69,12 +68,12 @@ public class EntityWolfEntry extends EntityEntry<WolfMob>{
         });
 
         entityWolf.setWolfHeldItem(null);
-        GuiListenerButton hasItem = new GuiListenerButton(-1, - 120, armor.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.item", false));
+        ListenerButtonElement hasItem = new ListenerButtonElement(-1, - 120, armor.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.item", false));
 
-        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, hasItem.yPosition + 21, 120, 20, 1) {
+        TextCycleElement<Integer> itemIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, hasItem.yPosition + 21, 120, 20, 1) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleItemId(current, offset);
+                return ModelViewerScreen.cycleItemId(current, offset);
             }
 
             @Override
@@ -98,7 +97,7 @@ public class EntityWolfEntry extends EntityEntry<WolfMob>{
         itemIdCycle.textField.setPrefaceText("ID: ");
         itemIdCycle.textField.setPlaceholder("Item ID");
 
-        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
+        TextCycleElement<Integer> metaCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return (current + offset) & 0x3FFF;
